package org.robert.printer.common;

import javax.print.PrintService;
import javax.print.PrintServiceLookup;

import org.json.JSONObject;

public abstract class PrintersDiscovery {

	/**
	 *
	 * @return
	 * @throws JSONException
	 */
	public static JSONObject getPrinterNames() {
		JSONObject json = new JSONObject();
		PrintService[] services = PrintServiceLookup.lookupPrintServices(null, null);

		for (PrintService service : services) {
			json.append("printers", service.getName());
		}

		return json;
	}

	/**
	 *
	 * @param printerName
	 * @return
	 */
	public static PrintService getPrintService(String printerName) {
		PrintService[] services = PrintServiceLookup.lookupPrintServices(null, null);

		for (PrintService service : services) {
			if (service.getName().equals(printerName)) {
				return service;
			}
		}

		return PrintServiceLookup.lookupDefaultPrintService();
	}
}
