package org.robert.printer.ui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import org.robert.printer.ws.PrintersSocketServer;

import dorkbox.systemTray.MenuItem;
import dorkbox.systemTray.SystemTray;

public class Tray {

	private SystemTray systemTray;
	private PrintersSocketServer server;

	/**
	 *
	 */
	public void start() {
		this.systemTray = SystemTray.get();

		if (this.systemTray == null) {
			return;
		}

		this.systemTray.setImage(this.getClass().getResource("resources/printer_ok.png"));

//		MenuItem startServerMenu = new MenuItem("Arrancar servidor", new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//				startServerActionListener(e);
//			}
//		});
//
//		MenuItem stopServerMenu = new MenuItem("Parar servidor", new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//				stopServerActionListener(e);
//			}
//		});

		MenuItem quitMenu = new MenuItem("Salir", new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				quitActionListener(e);
			}
		});

//		this.systemTray.getMenu().add(startServerMenu);
//		this.systemTray.getMenu().add(stopServerMenu);
		this.systemTray.getMenu().add(quitMenu);
	}

	/**
	 *
	 * @param e
	 */
	protected void startServerActionListener(ActionEvent e) {
		try {
			this.server.goUp();
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}

	/**
	 *
	 * @param e
	 */
	protected void stopServerActionListener(ActionEvent e) {
		try {
			this.server.goDown();
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}

	/**
	 *
	 * @param e
	 */
	protected void quitActionListener(ActionEvent e) {
		this.systemTray.shutdown();
		System.exit(0);
	}

	/**
	 *
	 * @param server
	 * @throws Exception
	 */
	public void setupServer(PrintersSocketServer server) throws Exception {
		if (server == null) {
			return;
		}

		this.server = server;
		this.server.goUp();
	}
}
